import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.utils"

import "SandBox.Crafters"

NewRecipeWindow = class( Turbine.UI.Window )

function NewRecipeWindow:Constructor()
    Turbine.UI.Lotro.Window.Constructor( self )
    self:SetSize( 340, 140 )
    self:SetPosition( 585, 335 )
    self:SetText( "New Recipe" )
    self:SetVisible( true )
    
    --I build labels
    self.namelabel = Turbine.UI.Label()
    self.namelabel:SetParent( self )
    self.namelabel:SetSize( 100, 20 )
    self.namelabel:SetPosition( 25, 40 )
    self.namelabel:SetText( "Recipe Name: " )
    self.namelabel:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    
    self.levlabel = Turbine.UI.Label()
    self.levlabel:SetParent( self )
    self.levlabel:SetSize( 100, 20 )
    self.levlabel:SetPosition( 25, 60 )
    self.levlabel:SetText( "Item Level: " )
    self.levlabel:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    
    self.sinlabel = Turbine.UI.Label()
    self.sinlabel:SetParent( self )
    self.sinlabel:SetSize( 100, 20 )
    self.sinlabel:SetPosition( 185, 60 )
    self.sinlabel:SetText( "Single Use: " )
    self.sinlabel:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )

    self.tierlabel = Turbine.UI.Label()
    self.tierlabel:SetParent( self )
    self.tierlabel:SetSize( 100, 20 )
    self.tierlabel:SetPosition( 25, 80 )
    self.tierlabel:SetText( "Teir: " )
    self.tierlabel:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )

    --I Build textboxes
    self.recbox = Turbine.UI.Lotro.TextBox()
    self.recbox:SetParent( self )
    self.recbox:SetSize( 180, 15 )
    self.recbox:SetPosition( 130, 40 )
    self.recbox:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
    self.recbox:SetMultiline( false )
    
    self.levbox = Turbine.UI.Lotro.TextBox()
    self.levbox:SetParent( self )
    self.levbox:SetSize( 30, 15 )
    self.levbox:SetPosition( 130, 60 )
    self.levbox:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
    self.levbox:SetMultiline( false )
  
    --I Idealy this would be a checkbox but having issues with them currently
    self.sincheck = Turbine.UI.Lotro.TextBox()
    self.sincheck:SetParent( self )
    self.sincheck:SetSize( 30, 15 )
    self.sincheck:SetPosition( 280, 60 )
    self.sincheck:SetFont( Turbine.UI.Lotro.Font.Verdana12 )
    self.sincheck:SetMultiline( false )

    --I Build combobox
    self.tbut = Turbine.UI.Lotro.Button()
    self.tbut:SetParent( self )
    self.tbut:SetSize( 80, 20 ) 
    self.tbut:SetPosition( 130, 80 )
    self.tbut:SetText( "Tier" )
    self.tbut.Click = function( sender, args )
        self.conmen:ShowMenu() 
    end
    
    self.conmen = Turbine.UI.ContextMenu()  
    self.menulist = self.conmen:GetItems()

    self.menulist:Add( Turbine.UI.MenuItem( "Apprentice" ) )
    self.menulist:Add( Turbine.UI.MenuItem( "Journeyman" ) )
    self.menulist:Add( Turbine.UI.MenuItem( "Artisan" ) )
    self.menulist:Add( Turbine.UI.MenuItem( "Expert" ) )
    self.menulist:Add( Turbine.UI.MenuItem( "Master" ) )
    self.menulist:Add( Turbine.UI.MenuItem( "Supreme" ) )
    
    for i = 1, self.menulist:GetCount( ) do
        local item = self.menulist:Get( i )
        item.Click = function( sender, args ) 
             self.tbut:SetText( sender:GetText() )
        end
    end
    
    --I Build Buttons
    self.savebut = Turbine.UI.Lotro.Button()
    self.savebut:SetParent( self )
    self.savebut:SetSize( 80, 20 )
    self.savebut:SetPosition( 25, 105 )
    self.savebut:SetText( "Save" )
    
    self.cancelbut = Turbine.UI.Lotro.Button()
    self.cancelbut:SetParent( self )
    self.cancelbut:SetSize( 80, 20 )
    self.cancelbut:SetPosition( 235, 105 )
    self.cancelbut:SetText( "Cancel" )
    self.cancelbut.Click = function( sender, args ) self:Clear() end
end
    
function NewRecipeWindow:bswitch( title ) 
    self.tbut:SetText( title )
end

function NewRecipeWindow:Clear( )
    self.recbox:SetText( "" )
    self.levbox:SetText( "" )
    self.sincheck:SetText( "" )
    --NewRecipeWindow.sincheck:SetChecked( true )
    self.tbut:SetText( "Tier" )
    self:SetVisible( false )
end