import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.utils"

import "SandBox.Crafters"

RecipeWindow = class( Turbine.UI.Window )

function RecipeWindow:Constructor()
    Turbine.UI.Lotro.Window.Constructor( self )
    self:SetSize( 340, 180 )
    self:SetPosition( 585, 150 )
    self:SetText( "Testing" )
    self:SetVisible( false )    
    
    self.recipes = {}
    
    self.tiers = { }
    self.tiers["Apprentice"] = {}
    self.tiers["Journeyman"] = {}
    self.tiers["Expert"] = {}
    self.tiers["Artisan"] = {}
    self.tiers["Master"] = {}
    self.tiers["Supreme"] = {}
    
    self.newrecwin = NewRecipeWindow()
    self.newrecwin:SetVisible( false )
    
    --I listbox for buttons
    self.butlist = Turbine.UI.ListBox()
    self.butlist:SetParent(self)
    self.butlist:SetSize( 85, 120 )
    self.butlist:SetPosition( 25, 40 )
    self.butlist:SetOrientation( Turbine.UI.Orientation.Horizontal )
    self.butlist:SetMaxItemsPerLine( 1 )

    self.recapp = Turbine.UI.Button()
    self.recapp:SetSize( 85, 20 )
    self.recapp:SetText( "Apprentice" )
    self.butlist:AddItem( self.recapp )
    self.recapp:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recapp:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.recapp.Click = function( sender, args ) self:changetier( "Apprentice" ) end
     
    self.recjou = Turbine.UI.Button()
    self.recjou:SetSize( 85, 20 )
    self.recjou:SetText( "Journeyman" )
    self.butlist:AddItem( self.recjou ) 
    self.recjou:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recjou:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.recjou.Click = function( sender, args ) self:changetier( "Journeyman" ) end
    
    self.recart = Turbine.UI.Button()
    self.recart:SetSize( 85, 20 )
    self.recart:SetText( "Artisan" )
    self.butlist:AddItem( self.recart )
    self.recart:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recart:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.recart.Click = function( sender, args ) self:changetier( "Artisan" ) end
    
    self.recexp = Turbine.UI.Button()
    self.recexp:SetSize( 85, 20 )
    self.recexp:SetText( "Expert" )
    self.butlist:AddItem( self.recexp )
    self.recexp:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recexp:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.recexp.Click = function( sender, args ) self:changetier( "Expert" ) end
      
    self.recmas = Turbine.UI.Button()
    self.recmas:SetSize( 85, 20 )
    self.recmas:SetText( "Master" )
    self.butlist:AddItem( self.recmas )
    self.recmas:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recmas:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.recmas.Click = function( sender, args ) self:changetier( "Master" ) end
    
    self.recsup = Turbine.UI.Button()
    self.recsup:SetSize( 85, 20 )
    self.recsup:SetText( "Supreme" )
    self.butlist:AddItem( self.recsup )
    self.recsup:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recsup:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    self.recsup.Click = function( sender, args ) self:changetier( "Supreme" ) end
    
    --I build titles
    self.reclabel = Turbine.UI.Label()
    self.reclabel:SetParent( self )
    self.reclabel:SetPosition( 115, 40 )
    self.reclabel:SetSize( 130, 20 )
    self.reclabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft )
    self.reclabel:SetText( "Recipe name" )
    self.reclabel:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    
    self.levlabel = Turbine.UI.Label()
    self.levlabel:SetParent( self )
    self.levlabel:SetPosition( 240, 40 )
    self.levlabel:SetSize( 30, 20 )
    self.levlabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft )
    self.levlabel:SetText( "Lvl" )
    self.levlabel:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    
    self.singlabel = Turbine.UI.Label()
    self.singlabel:SetParent( self )
    self.singlabel:SetSize( 30, 20 )
    self.singlabel:SetPosition( 270, 40 )
    self.singlabel:SetText( "Once" )
    self.singlabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft )
    self.singlabel:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    
    --I build listbox for recipes
    self.recscroll = Turbine.UI.Lotro.ScrollBar()
    self.recscroll:SetParent( self )
    self.recscroll:SetSize( 10, 80 )
    self.recscroll:SetPosition( 320, 45 )
    self.recscroll:SetOrientation( Turbine.UI.Orientation.Vertical )
    
    self.reclist = Turbine.UI.ListBox()
    self.reclist:SetVerticalScrollBar( self.recscroll )
    self.reclist:SetParent( self )
    self.reclist:SetPosition( 115, 60 )
    self.reclist:SetSize( 200, 80 )
    self.reclist:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) ) 
    self.reclist:SetOrientation( Turbine.UI.Orientation.Horizontal )
    self.reclist:SetMaxItemsPerLine( 1 )
    
    --I Setup New recipe button
    self.newrec = Turbine.UI.Lotro.Button()
    self.newrec:SetParent( self )
    self.newrec:SetSize( 100, 20 )
    self.newrec:SetPosition( 115, 140 )
    self.newrec:SetText( "New Recipe" )
    self.newrec.Click = function(sender, args)
        self.newrecwin:SetVisible( true )
        self.newrecwin.savebut.Click = function( sender, args) self:assemble() end

    end 
    self:changetier( "Apprentice" )   
end

function RecipeWindow:changetier( tier )
    local items = self.reclist:GetItemCount()
    if items == 0 then
        --D Turbine.Shell.WriteLine( "Listbox is currently empty" )
    else
        --D Turbine.Shell.WriteLine( "Attempting to clear the listbox" )
        for item = items, 1, -1 do
            --D Turbine.Shell.WriteLine( "Removing Item number " .. item )
            self.reclist:RemoveItemAt( item )
        end
    end
    local current = self.tiers[tier]
    --D Turbine.Shell.WriteLine( "Loading the recipes for the " .. tier .. " tier." )
    for i in pairs(current) do
        --D Turbine.Shell.WriteLine( "Attempting to load " .. i .. " recipe." )
        self.reclist:AddItem(current[i])
    end
    self.recapp:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recjou:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recexp:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recart:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) )
    self.recmas:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) ) 
    self.recsup:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) )
    if tier == "Apprentice" then
        self.recapp:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) )
    elseif tier == "Journeyman" then
        self.recjou:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) )
    elseif tier == "Expert" then
        self.recexp:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) )
    elseif tier == "Artisan" then
        self.recart:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) )
    elseif tier == "Master" then
        self.recmas:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) )
    elseif tier == "Supreme" then
        self.recsup:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) )
    else
        Turbine.Shell.WriteLine( "Error! Tier index out of range" )
    end
        
end

--I Collects data from the New Recipe Window and builds the base 'data' table
function RecipeWindow:assemble()
   
    local data = {}
    data.recname = self.newrecwin.recbox:GetText()
    local name = data.recname
    data.level = self.newrecwin.levbox:GetText()
    data.single = self.newrecwin.sincheck:GetText()
    data.tier = self.newrecwin.tbut:GetText()

    if data.tier == 'Tier' then
        Turbine.Shell.WriteLine( "Tier left blank, please select a Tier" )
    else
        self.recipes[data.recname] = data
        self:BuildItem( data )
        self.newrecwin:Clear()
    end
    --D Turbine.Shell.WriteLine( "did the data build correctly? " .. tiers[data.tier].name.name )
    
end

--I Builds the 'data' table into a displayable block
function RecipeWindow:BuildItem( data )
    local data = data
    local recname = data.recname
    local dtier = data.tier
    
    local listbox = Turbine.UI.ListBox()
    listbox:SetEnabled( true )
    listbox:SetSize( 200, 15 )
    listbox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    listbox:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) )
    function listbox:MouseEnter( args )
        listbox:SetBackColor( Turbine.UI.Color( .2, .2, .2 ) )
    end
    function listbox:MouseLeave( args )
        listbox:SetBackColor( Turbine.UI.Color( .1, .1, .1 ) )
    end
    
    local recipename = Turbine.UI.Label()
    recipename:SetSize( 125, 10 )
    recipename:SetParent( listbox )
    recipename:SetText( recname )
    recipename:SetMultiline( false )
    recipename:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    listbox:AddItem( recipename )
    
    local level = Turbine.UI.Label()
    level:SetSize( 30, 10 )
    level:SetParent( listbox )
    level:SetText( data.level )
    level:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) )
    listbox:AddItem( level )
    
    local single = Turbine.UI.Label()
    single:SetSize( 30, 10 )
    single:SetParent(  listbox )
    single:SetText( data.single )
    single:SetForeColor( Turbine.UI.Color( 1, .8, .6 ) ) 
    listbox:AddItem( single )
    --D Turbine.Shell.WriteLine( data.tier )
    
    local delbut = Turbine.UI.Button()
    delbut:SetSize( 10, 10 )
    delbut:SetText("X")
    listbox:AddItem( delbut )
    
    local ctier = self.tiers[dtier]
    ctier[recname] = listbox
    self:changetier(data.tier)
    delbut.Click = function( sender, args ) 
        ctier[recname] = nil 
        self.recipes[recname] = nil
        self:changetier(data.tier) 
    end
    
end